#!/usr/bin/env python

"""
Acorn Electron ULA simulation controller.
"""

from ula import *
import pygame

def mainloop():
    while 1:
        pygame.display.flip()
        event = pygame.event.wait()
        if event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
            break

if __name__ == "__main__":
    pygame.init()
    screen = pygame.display.set_mode((WIDTH, HEIGHT), 0)
    a = pygame.surfarray.pixels3d(screen)

    memory = get_memory()
    ula = ULA(memory)

    # Test MODE 2.

    ula.set_mode(2)

    fill(memory, 0x3000, 0x5800 - 320, encode((1, 6), 4))
    fill(memory, 0x5800 - 320, 0x8000, encode((2, 7), 4))
    update(a, ula)
    mainloop()

    ula.screen_start = 0x3000 + 2
    update(a, ula)
    mainloop()

    # Test MODE 6.

    ula.set_mode(6)

    fill(memory, 0x6000, 0x6f00 + 160, encode((1, 0, 1, 1, 0, 0, 1, 1), 1))
    fill(memory, 0x6f00 + 160, 0x7f40, encode((1, 0, 1, 0, 1, 0, 1, 0), 1))
    update(a, ula)
    mainloop()

    ula.screen_start = 0x6f00 + 160
    update(a, ula)
    mainloop()

# vim: tabstop=4 expandtab shiftwidth=4
